// XADecompress.h: interface for the XADecompress class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_XADECOMPRESS_H__1B39E52C_551C_455B_9E68_5E9249B2282E__INCLUDED_)
#define AFX_XADECOMPRESS_H__1B39E52C_551C_455B_9E68_5E9249B2282E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

extern float facttable1[4];
extern float facttable2[4];
extern long table[16][16];

void _inittables(void);

class XADecompress  
{
public:
	class XATrack
	{
	public:
		XATrack();
		long row;
		long Last, PreLast;
		float factLast, factPreLast;
		DWORD pos;
		unsigned short process(unsigned char token)
		{
			long temp = long(factLast * Last + factPreLast * PreLast +
				table[row][token]);
			PreLast = Last;
			Last = temp;
			return (unsigned short)temp;
		}
	} *Track;
	DWORD Tracks;

	class XABuffer
	{
	public:
		bool tokenhigh;
		unsigned char current_byte;
		unsigned char *data;
		unsigned long length, pos;
		bool get(unsigned char &token)
		{
			if (tokenhigh)
			{
				if (pos>=length) return false;
				current_byte = data[pos++];
				token = current_byte>>4;
				tokenhigh = false;
				return true;
			}
			else
			{
				token = current_byte&15;
				tokenhigh = true;
				return true;
			}
		}
		void Init(unsigned char *data, unsigned long length)
		{
			this->data = data;
			this->length = length;
			pos = 0;
			current_byte = 0;
			tokenhigh = true;
		}
	};


	XADecompress();
	virtual ~XADecompress();

	void Init(BYTE *Input, DWORD InSize, CFile *Output);
	BOOL Decompress();

	BYTE *pMap;
	DWORD Size, Pos;

	CFile *output;

};

#endif // !defined(AFX_XADECOMPRESS_H__1B39E52C_551C_455B_9E68_5E9249B2282E__INCLUDED_)
